<?php
class MGL_InstagramGalleryUser extends MGL_InstagramGalleryBase {

    public function __consctruct( $args ){
        $this->type = 'auth';
        parent::__construct( $args );
    }

    public function getUrlRequestToGetGalleryFromInstagramServer(){

        if( $this->username != '' ){ 
            $this->userId = $this->getUserId( $this->username );
        }

        $nextUrl = ($this->nextId != '') ? '&max_id='.$this->nextId : '';
        $urlRequest = 'https://api.instagram.com/v1/users/'.$this->userId.'/media/recent/?access_token='.$this->accessToken.'&count='.$this->count.$nextUrl;

        return $urlRequest;
    }

    public function configureNavigation(){
        if(isset($this->gallery->pagination->next_max_id)) {
            $this->nextId = $this->gallery->pagination->next_max_id;
        }
    }

    public function getUserId(){
        $this->username = strtolower( $this->username );

        $key = "mgl_ins_user_".$this->username.'_id';

        // Search if we already have this users_id
        if ( false != ( $cachedId = get_transient( $key ) ) ) {
            return $cachedId;
        }
        
        $url = "https://api.instagram.com/v1/users/search?q=".$this->username."&access_token=".$this->accessToken;

        $instagramResponse = $this->getInstagramResponse( $url );
        $jsonResponse = json_decode( $instagramResponse );
        $users = $jsonResponse->data;

        if( $this->debug ) { echo '<pre>'; print_r( $json ); echo '</pre>'; }

        foreach($users as $user){
            if($user->username == $this->username){
                set_transient( $key, $user->id, 86400 );
                return $user->id;
            }
        }
        return 0; // return this if nothing is found
        
    }
}