<?php

/* Widget */
class mgl_Instagram_location extends WP_Widget {

	/* Widget Setup */
	function mgl_Instagram_location() {

		/* Widget settings. */
		$widget_ops = array( 'classname' => 'mgl_instagram_location_gallery', 'description' => __('Display the last Instagram media from a location', 'mgl_instagram_gallery') );

		/* Widget control settings. */
		$control_ops = array( 'id_base' => 'mgl_instagram_location_widget' );

		/* Create the widget. */
		$this->WP_Widget( 'mgl_instagram_location_widget', 'MaGeek Lab - '.__('Instagram Location Gallery', 'mgl_instagram_gallery'), $widget_ops, $control_ops );
	}


	/* Display Widget */
	function widget( $args, $instance ) {
		extract( $args );

		/* Our variables from the widget settings. */
		$title = apply_filters('widget_title', $instance['title'] );
                
        $title 			= $instance['title'];	
		$number 		= $instance['number'];	
		$columns 		= $instance['columns'];
		$location_id 	= $instance['location_id'];
		$cache 			= $instance['cache'];
		$video 			= $instance['video'];

		$direct_link 	= $instance['direct_link'];
		$disable_js 	= $instance['disable_js'];
		$skin 			= $instance['skin'];
		$responsive 	= $instance['responsive'];

		/* Before widget (defined by themes). */
		echo $before_widget;

		if($video != 'on') { $video = false; } else { $video = true; }
		if($direct_link != 'on') { $direct_link = false; } else { $direct_link = true; }
		if($disable_js != 'on') { $disable_js = false; } else { $disable_js = true; }
		if($responsive != 'on') { $responsive = false; } else { $responsive = true; }

		/* Display the widget title if one was input (before and after defined by themes). */
		if ( $title )
			echo $before_title . $title . $after_title;
		 
		$args = array(
            'count' => $number,
            'user_id' => false,
            'username' => false,
            'location_id' => $location_id,
            'tag' => false,
            'cache' => $cache,
            'pagination' => false,
            'cols' => $columns,
            'more_text' => false,
            'previous_text' => false,
            'cut_text' => false,
            'video' => $video,
            'direct_link' => $direct_link,
            'disable_js' => $disable_js,
            'skin'    => $skin,
            'responsive' => $responsive,
            'debug' => false
        );

		$gallery = new MGL_InstagramGalleryLocation( $args );
		echo '<div class="mgl_instagram_gallery_widget">'. $gallery->render() .'</div>';


		/* After widget (defined by themes). */
		echo $after_widget;
	}

	/* Update Widget */
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* Strip tags for title and name to remove HTML (important for text inputs). */
		$instance['title'] 		= strip_tags( $new_instance['title'] );     
		$instance['number'] 	= strip_tags( $new_instance['number'] );              
		$instance['columns'] 	= strip_tags( $new_instance['columns'] );  
		$instance['location_id']= strip_tags( $new_instance['location_id'] );
		$instance['cache'] 		= strip_tags( $new_instance['cache'] );
		$instance['skin'] 		= strip_tags( $new_instance['skin'] );
		/* No need to strip tags for.. */
		$instance['video'] 		= $new_instance['video'];
		$instance['direct_link']= $new_instance['direct_link'];
		$instance['disable_js']	= $new_instance['disable_js'];
		$instance['responsive'] = $new_instance['responsive'];

		return $instance;
	}

	/*  Widget Settings */

	/**
	 * Displays the widget settings controls on the widget panel.
	 * Make use of the get_field_id() and get_field_name() function
	 * when creating your form elements. This handles the confusing stuff.
	 */
	function form( $instance ) {

		/* Set up some default widget settings. */
		$defaults = array(
		'title' => 'My location',
        'user_id' => '',
        'number' => 4,
        'columns' => 2,
		'cache' => 3600,
		'video' => 'on',
		'location_id' => '',
		'skin' => 'default',
		'responsive' => 'on',
		'direct_link' => '',
		'disable_js' => '',
		);
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title', 'mgl_instagram_gallery') ?>:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" />
		</p>

		 <p>
			<label for="<?php echo $this->get_field_id( 'location_id' ); ?>"><?php _e('Location ID', 'mgl_instagram_gallery') ?>:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'location_id' ); ?>" name="<?php echo $this->get_field_name( 'location_id' ); ?>" value="<?php echo $instance['location_id']; ?>" />
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'number' ); ?>"><?php _e('Number', 'mgl_instagram_gallery') ?>:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'number' ); ?>" name="<?php echo $this->get_field_name( 'number' ); ?>" value="<?php echo $instance['number']; ?>" />
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'columns' ); ?>"><?php _e('Columns', 'mgl_instagram_gallery') ?>:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'columns' ); ?>" name="<?php echo $this->get_field_name( 'columns' ); ?>" value="<?php echo $instance['columns']; ?>" />
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'cache' ); ?>"><?php _e('Cache', 'mgl_instagram_gallery') ?>:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'cache' ); ?>" name="<?php echo $this->get_field_name( 'cache' ); ?>" value="<?php echo $instance['cache']; ?>" />
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'skin' ); ?>"><?php _e('Skin', 'mgl_instagram_gallery') ?>:</label>
			<?php $skins = array('default', 'basic', 'instagram', 'whiteslide', 'darkslide', 'elegant', 'dark'); ?>
			<select class="widefat" id="<?php echo $this->get_field_id( 'skin' ); ?>" name="<?php echo $this->get_field_name( 'skin' ); ?>" >
				<?php foreach ($skins as $key => $skin) { ?>
					<option value="<?php echo $skin; ?>" <?php if($instance['skin'] == $skin) { echo 'selected="selected"'; } ?>><?php echo $skin; ?></option>
				<?php } ?>
			</select>
			
		</p>

		<p>
			<?php if($instance['video'] == 'on') { $checked = 'checked="checked"'; } else { $checked = ''; } ?>
			<label for="<?php echo $this->get_field_id('video'); ?>">
			<input type="checkbox" id="<?php echo $this->get_field_id('video'); ?>" name="<?php echo $this->get_field_name('video'); ?>" <?php echo $checked; ?>  /> <?php _e('Include videos?', 'mgl_instagram_gallery') ?></label>
		<br />
			<?php if($instance['direct_link'] == 'on') { $checked = 'checked="checked"'; } else { $checked = ''; } ?>
			<label for="<?php echo $this->get_field_id('direct_link'); ?>">
			<input type="checkbox" id="<?php echo $this->get_field_id('direct_link'); ?>" name="<?php echo $this->get_field_name('direct_link'); ?>" <?php echo $checked; ?>  /> <?php _e('Direct link to Instagram', 'mgl_instagram_gallery') ?></label>
		<br />
			<?php if($instance['disable_js'] == 'on') { $checked = 'checked="checked"'; } else { $checked = ''; } ?>
			<label for="<?php echo $this->get_field_id('disable_js'); ?>">
			<input type="checkbox" id="<?php echo $this->get_field_id('disable_js'); ?>" name="<?php echo $this->get_field_name('disable_js'); ?>" <?php echo $checked; ?>  /> <?php _e('Disable javascript', 'mgl_instagram_gallery') ?></label>
		<br />
			<?php if($instance['responsive'] == 'on') { $checked = 'checked="checked"'; } else { $checked = ''; } ?>
			<label for="<?php echo $this->get_field_id('responsive'); ?>">
			<input type="checkbox" id="<?php echo $this->get_field_id('responsive'); ?>" name="<?php echo $this->get_field_name('responsive'); ?>" <?php echo $checked; ?>  /> <?php _e('Responsive', 'mgl_instagram_gallery') ?></label>
		</p>
	<?php
	}
}

?>